<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 29/06/12
 * Time: 10:37
 * To change this template use File | Settings | File Templates.
 */
 
class RegistroEmpregadorHomolognet extends RegistroHomolognet {

    // Constantes de <TAG>                                            // Layout       Arquivo
    const EMPREGADOR = 'Empregador';
    const TIPO_INSCRICAO = 'TPInscricao';                                 // 1          1
	const CNPJ_CEI = 'NRCnpjCei';                                         // 2          2
	const RAZAO_SOCIAL = 'NORazaoSocial';                                 // 3          3
    const ENDERECO = 'Endereco';
    const CEP = 'NRCep';                                                  // 4          9
    const LOGRADOURO = 'EDLogradouro';                                    // 5          10
    const NR_ENDERECO= 'NREndereco';                                      // 6          11
    const COMPLEMENTO = 'DSComplemento';                                  // 7          12
    const BAIRRO = 'NOBairro';                                            // 8          13
    const MUNICIPIO = 'NOMunicipio';                                      // 9          14
    const ESTADO = 'SGUF';                                                // 10         15
    const CNAE = 'Cnae';                                                  // 11         8
    const CNPJ_ESP_CEES = 'NRCnpjEspCees';                                // 12         4
    const NR_CODIGO_SINDICAL_ESP_CEES = 'NRCodigoSindicalEspCees';        // 13         5
    const TIPO_INSCRICAO_TOMADOR = 'TPInscricaoTomadorObra';              // 14         6
    const CNPJ_CEI_TOMADOR_OBRA = 'NRCnpjCeiTomadorObra';                 // 15         7

    private $_nrTpInscricao;
    private $_nrInscricao;
    private $_nrTpInscricaoTom;
    private $_nrInscricaoTom;
    private $_estrutura;

    
    public function geraRegistroEmpregador(){

        $this->_geraRegistro();
    }


    private function _geraRegistro(){

        parent::geraRegistro(null, null, null);


        // Campo 1 - Tamanho 01 - Tipo de Inscrição
        $this->_atribuiTipoInscricao();

        // Campo 2 - Tamanho - 14 - CNPJ/CEI
        $this->_atribuiNrInscricao();

        // Campo 3 - Tamanho 150 - Razão Social/Nome
        $this->_atribuiRazaoSocial();

        // Campo 12 - Tamanho 14 - CNPJ da Entidade SindicalPatronal ou da Conta Especial Emprego Salário (CEES/MTE)
        //@todo - Verificar Conta Especial Emprego Salario (CEES)
        $this->_atribuiCNPJSindPatronalCEES();

        // Campo 13 - Tamanho 15 - Código Sindical da Entidade Sindical Patronal
        $this->_atribuiCodigoSindical();

        // Campo 14 - Tamanho 1 - Tipo de inscrição Tomador/obra (1= CNPJ / 2 = CEI)
        $this->_atribuiTipoInscricaoTomador();

        // Campo 15 - Tamanho 14 - CNPJ/CEI Tomador/Obra
        $this->_atribuiNrInscricaoTomador();

        // Campo 11 - Tamanho 7 - CNAE
        $this->_atribuiCNAE();

        // Atribuicao da tag Endereco
        $tag = self::ENDERECO;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

        // Campo 4 - Tamanho 8 - CEP
        $this->_atribuiCEP();

        // Campo 5 - Tamanho 200 - Logradouro
        $this->_atribuiLogradouro();

        // Campo 6 - Tamanho 15 - Numero
        $this->_atribuiNumero();

        // Campo 7 - Tamanho 30 - Complemento
        $this->_atribuiComplemento();

        // Campo 8 - Tamanho 144 - Bairro
        $this->_atribuiBairro();

        // Campo 9 - Tamanho 144 - Município
        $this->_atribuiMunicipio();

        // Campo 10 - Tamanho 2 - UF
        $this->_atribuiEstado();

        $tag = parent::CARACTER_FINALIZADOR;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

    }


    private function _atribuiTipoInscricao(){
        // Informar de acordo com os seguintes domínios: 1 = CNPJ / 2 = CEI
        if (empty($this->_nrTpInscricao) === false) {
            $tag = self::TIPO_INSCRICAO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $this->_nrTpInscricao, 1);
        }
    }


    private function _atribuiNrInscricao(){
        // Informar de acordo com os seguintes formatos: CNPJ: 99999999999999  / CEI: 999999999999
        if (empty($this->_nrTpInscricao) === false) {
            $tag = self::CNPJ_CEI.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $this->_nrInscricao, 14);
        }
    }


    private function _atribuiRazaoSocial(){
        $dado = $this->_estrutura->historico->getNmrazsocestrut();
        if (empty($dado) === false){
            $tag = self::RAZAO_SOCIAL.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 150);
        }
    }


    private function _atribuiCEP(){
        // Informar de acordo com o seguinte formato: 9999999
        $dado = $this->_estrutura->endereco->getNrcependereco();
        if (empty($dado) === false){
            $tag = self::CEP.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 8);
        }
    }


    private function _atribuiLogradouro(){
        $dado = $this->_estrutura->endereco->getEndereco();
        if (empty($dado) === false){
            $tag = self::LOGRADOURO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 200);
        }
    }


    private function _atribuiNumero(){
        $dado = $this->_estrutura->endereco->getNumero();
        if (empty($dado) === false){
            $tag = self::NR_ENDERECO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 15);
        }
    }


    private function _atribuiComplemento(){
        $dado = $this->_estrutura->endereco->complemento;
        if (empty($dado) === false) {
            $tag = self::COMPLEMENTO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 30);
        }
    }


    private function _atribuiBairro(){
        $dado = $this->_estrutura->endereco->bairro;
        if (empty($dado) === false) {
            $tag = self::BAIRRO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 144);
        }
    }


    private function _atribuiMunicipio(){
        $dado = $this->_estrutura->endereco->municipio;
        if (empty($dado) === false) {
            $tag = self::MUNICIPIO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 144);
        }
    }


    private function _atribuiEstado(){
        $dado = $this->_estrutura->endereco->getSgestado();
        if (empty($dado) === false) {
            $tag = self::ESTADO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 2);
        }
    }


    private function _atribuiCNAE(){
        $dado = $this->_estrutura->historico->getCdcnae();
        if (empty($dado) === false) {
            $tag = self::CNAE.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 7);
        }
    }

    
    private function _atribuiCNPJSindPatronalCEES(){
         /* Informar de acordo com o seguinte formato: 99999999999999
          * Se a empresa estiver regularmente inscrita como “Optante do Simples Nacional”, informar o CNPJ da Conta Especial Emprego e Salário (CEES/MTE).
          *
          *     CNPJ: 37.115.367/0035-00
                Código Sindical: 999
                Nome da Entidade Sindical: CEES-CONTA ESPECIAL EMPREGO E SALARIO
          *
          */

         //@todo - Se empresa optante pelo SIMPLES informar o CNPJ da CEES
         $dado = '37115367003500';
         if (empty($dado) === false) {
             $tag = self::CNPJ_ESP_CEES.parent::CARACTER_ATRIBUI;
             $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14);
         }

    }


    private function _atribuiCodigoSindical(){
        /* Informar de acordo com o seguinte formato: 999999999999999
         * Este campo não será obrigatório, se o CNAE e/ou CBO informados forem relacionados a Trabalho Rural.
         * Preencher com 3 zeros à esquerda.
         */
        //@todo - Valor conforme campo anterior
        $dado = '000999999999999';
        if (empty($dado) === false) {
            $tag = self::NR_CODIGO_SINDICAL_ESP_CEES.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 15);
        }
    }


    private function _atribuiTipoInscricaoTomador(){
        if (empty($this->_nrTpInscricaoTom) === false) {
            $tag = self::TIPO_INSCRICAO_TOMADOR.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $this->_nrTpInscricaoTom, 1);
        }
    }


    private function _atribuiNrInscricaoTomador(){
        // Informar de acordo com os seguintes formatos: CNPJ: 99999999999999  / CEI: 999999999999
        if (empty($this->_nrInscricaoTom) === false) {
            $tag = self::CNPJ_CEI_TOMADOR_OBRA.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $this->_nrInscricaoTom, 14);
        }
    }


    public function setNrInscricao($nrInscricao) {
        $this->_nrInscricao = $nrInscricao;
    }


    public function setNrInscricaoTom($nrInscricaoTom) {
        $this->_nrInscricaoTom = $nrInscricaoTom;
    }


    public function setNrTpInscricao($nrTpInscricao) {
        $this->_nrTpInscricao = $nrTpInscricao;
    }


    public function setNrTpInscricaoTom($nrTpInscricaoTom) {
        $this->_nrTpInscricaoTom = $nrTpInscricaoTom;
    }

    public function setEstrutura($estrutura){
        $this->_estrutura = $estrutura;
    }

    public function geraTagEmpregador($dominio, $noPrincipal){
        return $this->_geraTag($dominio, $noPrincipal);
    }




}
