CREATE OR REPLACE TRIGGER LOG_FIS_PRE_VD_SPED
AFTER UPDATE OR INSERT OR DELETE
ON IMPOSTO FOR EACH ROW
DECLARE
   V_USUARIO  VARCHAR2(40);
   V_OPERACAO VARCHAR2(300);
BEGIN
   NMUSUARIO(V_USUARIO);
   IF UPDATING THEN
      IF :OLD.IDIMPVALIDASPED <> :NEW.IDIMPVALIDASPED THEN
         V_OPERACAO := 'Foi alterado o parmetro IDIMPVALIDASPED para '||:NEW.IDIMPVALIDASPED||'.';
         
         INSERT INTO LOGOPERA
            (NMTABELA, DTOPERACAO, NMRESPOPER, CDPESQITEM, IDTIPOOPER, DSOPERACAO)
         VALUES
            ('IMPOSTO', SYSDATE, V_USUARIO, :NEW.CDIMPOSTO, '2', V_OPERACAO);
      END IF;
   ELSIF INSERTING THEN
      V_OPERACAO := 'Foi criado o imposto com o parmetro IDIMPVALIDASPED = '||:NEW.IDIMPVALIDASPED||'.';
      
      INSERT INTO LOGOPERA
         (NMTABELA, DTOPERACAO, NMRESPOPER, CDPESQITEM, IDTIPOOPER, DSOPERACAO)
      VALUES
         ('IMPOSTO', SYSDATE, V_USUARIO, :NEW.CDIMPOSTO, '1', V_OPERACAO);
   ELSE
      V_OPERACAO := 'Foi apagado o imposto com o parmetro IDIMPVALIDASPED = '||:OLD.IDIMPVALIDASPED||'.';      
      
      INSERT INTO LOGOPERA
         (NMTABELA, DTOPERACAO, NMRESPOPER, CDPESQITEM, IDTIPOOPER, DSOPERACAO)
      VALUES
         ('IMPOSTO', SYSDATE, V_USUARIO, :OLD.CDIMPOSTO, '3', V_OPERACAO);
   END IF;
END;
/