/* Sistemas Integrados TEKNISA
  Integrao - SAGA

 Nome: Rotina de exportao das pessoas fsicas

Criao:
28/03/2013 - Fabrcio Marcelo

@C:\web_545\sql\end_conv\oracle\clientes\ris\6410_RISSTPO_Exporta_Pessoa_Fisica_Saga.SQL
*/

CREATE OR REPLACE PROCEDURE EXPORTA_PESSOA_FISICA_SAGA
AS
   V_NRCONTADOR   INT;
BEGIN
   V_NRCONTADOR := 0;

   /* Novos registros e Registros alterados */
   FOR C_PSF IN (SELECT 'C' AS ID, F.CDCLIENTE, F.NRINSJURCLIE AS NRINSJUR, F.NMRAZSOCCLIE AS NMRAZAOSOC, F.NMFANTCLIE AS NMFANTASIA, E.NRCEPCLIE AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRCLIE AS NMBAIRRO,
                        E.DSENDECLIE AS DSENDERECO
                   FROM CLIENTE F, ENDECLIE E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.IDTPIJURCLIE = 'F'
                    AND F.DTEXPCLIESAGA IS NULL
                    AND E.CDCLIENTE = F.CDCLIENTE
                    AND E.IDTPENDECLIE = 'P'
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO

                  UNION ALL

                 SELECT 'C' AS ID, F.CDCLIENTE, F.NRINSJURCLIE AS NRINSJUR, F.NMRAZSOCCLIE AS NMRAZAOSOC, F.NMFANTCLIE AS NMFANTASIA, E.NRCEPCLIE AS CEP,
                        P.NMPAIS, ES.NMESTADO, M.NMMUNICIPIO, E.NMBAIRCLIE AS NMBAIRRO,
                        E.DSENDECLIE AS DSENDERECO
                   FROM CLIENTE F, ENDECLIE E, PAIS P, ESTADO ES, MUNICIPIO M
                  WHERE F.IDTPIJURCLIE = 'F'
                    AND E.CDCLIENTE = F.CDCLIENTE
                    AND E.IDTPENDECLIE = 'P'
                    AND ((F.DTULTATUCLIE >= F.DTEXPCLIESAGA) OR (E.DTULTATUECLI >= F.DTEXPCLIESAGA))
                    AND P.CDPAIS = E.CDPAIS
                    AND ES.CDPAIS = E.CDPAIS
                    AND ES.SGESTADO = E.SGESTADO
                    AND M.CDPAIS = E.CDPAIS
                    AND M.SGESTADO = E.SGESTADO
                    AND M.CDMUNICIPIO = E.CDMUNICIPIO)
   LOOP
      INSERT INTO INT_CADPSF
         (CODPSS, NOMPSS, NOMAPEPSS, CODSITPSF, CODTIPCRTMTR, DATADM, DATDEM,
          NUMCRATRB, NUMINSS, NUMPIS, NUMTITELE, CODNATPSS, CODPPSEXT, BOLPDRCRP,
          CEP, CODTIPENDPTL, NOMPAI, NOMUFE, NOMLOC, NOMBRO, NOMRUA, NUMCMP,
          NOMCMP, DATCAD, FLAPRC, DSCERR, DATULTPRC, NUMIDPSSPRM, NUMIDPSSSCG)
      VALUES
         (C_PSF.NRINSJUR, C_PSF.NMRAZAOSOC, C_PSF.NMFANTASIA, 1, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, 16, NULL, 1,
          C_PSF.CEP, 1, C_PSF.NMPAIS, C_PSF.NMESTADO, C_PSF.NMMUNICIPIO, C_PSF.NMBAIRRO, C_PSF.DSENDERECO, NULL,
          NULL, SYSDATE, '0', NULL, NULL, NULL, NULL);

      V_NRCONTADOR := V_NRCONTADOR + 1;

      /* Relacionamento da pessoa fisica com a filial */
      FOR C_FILIAL IN (SELECT DISTINCT CDFILIALSAGA
                         FROM PARAMFILIAL
                        WHERE NOT CDFILIALSAGA IS NULL)
      LOOP
         INSERT INTO INT_CADACSPSS
            (CODSTE, CODTRN, CODPSS, FLAPRC, DSCERR, DATULTPRC)
         VALUES
            (C_FILIAL.CDFILIALSAGA, 0, C_PSF.NRINSJUR, '0', NULL, NULL);

         V_NRCONTADOR := V_NRCONTADOR + 1;
      END LOOP;

      IF C_PSF.ID = 'C' THEN
         UPDATE CLIENTE
            SET DTEXPCLIESAGA = SYSDATE
          WHERE CDCLIENTE = C_PSF.CDCLIENTE;

         V_NRCONTADOR := V_NRCONTADOR + 1;
      END IF;

      IF V_NRCONTADOR = 500 THEN
         V_NRCONTADOR := 0;
         COMMIT;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_PESSOA_FISICA_SAGA','5.45.XXX'); END;
/

